using System;
using System.Text;
using System.Text.RegularExpressions;
using Microsoft.VisualBasic;

namespace StringHelperTest
{
	class Test
	{
		[STAThread]
		static void Main(string[] args)
		{
			string segment = "лaBc͹";
			string source;
			string pattern = "abc";
			string destination = "";
			string result = "";
			const long count = 1000;
			StringBuilder pressure = new StringBuilder();
			HiPerfTimer time;

			for (int i = 0; i < count; i++)
			{
				pressure.Append(segment);
			}
			source = pressure.ToString();
	
			//regexp
			time = new HiPerfTimer();
			time.Start();
			for (int i = 0; i < count; i++)
			{
				result = Regex.Replace(source, pattern, destination, RegexOptions.IgnoreCase);
			}
			time.Stop();

			Console.WriteLine("regexp    =" + time.Duration + ":");


			//vb
			time = new HiPerfTimer();
			time.Start();
			for (int i = 0; i < count; i++)
			{
				result = Strings.Replace(source, pattern, destination, 1, -1, CompareMethod.Text);
			}
			time.Stop();

			Console.WriteLine("vb        =" + time.Duration + ":");


			//vbReplace
			time = new HiPerfTimer();
			time.Start();
			for (int i = 0; i < count; i++)
			{
				result = VBString.Replace(source, pattern, destination, 1, -1, StringCompareMethod.Text);
			}
			time.Stop();

			Console.WriteLine("vbReplace =" + time.Duration + ":" + result);


			//substring
			time = new HiPerfTimer();
			time.Start();
			for (int i = 0; i < count; i++)
			{
				result = StringHelper.ReplaceText(source, pattern, destination, StringHelper.CompareMethods.Text);
			}
			time.Stop();

			Console.WriteLine("substring =" + time.Duration + ":");


			//substring with stringbuilder
			time = new HiPerfTimer();
			time.Start();
			for (int i = 0; i < count; i++)
			{
				result = StringHelper.ReplaceTextB(source, pattern, destination, StringHelper.CompareMethods.Text);
			}
			time.Stop();

			Console.WriteLine("substringB=" + time.Duration + ":");


			Console.ReadLine();
		}

	}
}
